<?php
declare (strict_types = 1);

namespace app\admin\controller;
use think\facade\View;
use think\facade\Db;
use think\facade\Cache;
use think\facade\App;
use think\Request;
use think\facade\Log;


class Index extends Common
{

    public function menu()
    {
        $model=Db::name('model')->where('status',1)->where('type',2)->field(['concat(ifnull(name,""),"内容") as title','concat("/admin/content/?id=",ifnull(id,"")) as href','concat("fa fa-file-text-o",ifnull("","")) as icon','concat("_self",ifnull("","")) as target'])->order('sort asc,id asc')->select();
        $single=Db::name('model')->where('status',1)->where('type',1)->field(['concat(ifnull(name,""),"内容") as title','concat("/admin/single/?id=",ifnull(id,"")) as href','concat("fa fa-file-text-o",ifnull("","")) as icon','concat("_self",ifnull("","")) as target'])->order('sort asc,id asc')->select();
        $result = $model->merge($single);

        // 获取动态数据（除了留言表之外的其他表）
        $dynamicForms = Db::name('form')->where('id', '<>', '1')->order('id asc')->select();

        // 构建动态数据菜单项
        $dynamicMenuItems = [];
        foreach ($dynamicForms as $form) {
            $dynamicMenuItems[] = [
                'title' => $form['form_name'],
                'href' => '/admin/more/index/id/'. $form['id'],
                'icon' => 'fa fa-plus-square-o',
                'target' => '_self',
            ];
        }

        

        $menu = [
        
            'homeInfo'=>array
            (
                'title'=>"首页",
                'href'=>"/admin/index/welcome"
            ),
            'logoInfo'=>array
            (
                'title'=>"网站后台",
                'href'=>"",
                'image'=>"/public/static/admin/images/logo.png"
            ),
            'menuInfo'=>array
            (
                [
                    'title'=>'常规管理',
                    'href'=>'',
                    'icon'=>'fa fa-address-book',
                    'target'=>'_self',
                    'child'=>array
                    (
                        [
                            'title'=>'后台首页',
                            'href'=>'/admin/index/welcome',
                            'icon'=>'fa fa-home',
                            'target'=>'_self'
                        ],
                        [
                            'title'=>'全局设置',
                            'href'=>'',
                            'icon'=>'fa fa-globe',
                            'target'=>'_self',
                            'child'=>array
                            (
                                [
                                
                                    'title'=>'配置参数',
                                    'href'=>'/admin/config',
                                    'icon'=>'fa fa-sliders',
                                    'target'=>'_self',
                                ],
                                [
                                
                                    'title'=>'定制标签',
                                    'href'=>'/admin/label',
                                    'icon'=>'fa fa-wrench',
                                    'target'=>'_self',
                                ],
                                [
                            
                                'title'=>'模型管理',
                                'href'=>'/admin/model',
                                'icon'=>'fa fa-codepen',
                                'target'=>'_self',
                                ],
                                [
                                
                                    'title'=>'模型字段',
                                    'href'=>'/admin/extfield',
                                    'icon'=>'fa fa-external-link',
                                    'target'=>'_self',
                                ],
                            )
                        
                        ],
                        [
                            'title'=>'菜单管理',
                            'href'=>'/admin/category',
                            'icon'=>'fa fa-window-maximize',
                            'target'=>'_self'
                        ],
                        [
                            'title'=>'内容管理',
                            'href'=>'',
                            'icon'=>'fa fa-list-alt',
                            'target'=>'_self',
                            'child'=>$result,
                        ],
                        [
                            'title'=>'扩展内容',
                            'href'=>'',
                            'icon'=>'fa fa-arrows-alt',
                            'target'=>'_self',
                            'child' => array_merge([
                                [
                                    'title' => '留言信息',
                                    'href' => '/admin/msg',
                                    'icon' => 'fa fa-question-circle-o',
                                    'target' => '_self',
                                ],
                                [
                                    'title' => '轮播图片',
                                    'href' => '/admin/banner',
                                    'icon' => 'fa fa-picture-o',
                                    'target' => '_self',
                                ],
                                [
                                    'title' => '友情链接',
                                    'href' => '/admin/link',
                                    'icon' => 'fa fa-link',
                                    'target' => '_self',
                                ],
                                [
                                    'title' => '自定义表单',
                                    'href' => '/admin/form',
                                    'icon' => 'fa fa-plus-square-o',
                                    'target' => '_self',
                                ],
                            ], $dynamicMenuItems)
                        ],
                        [
                            'title'=>'会员模块',
                            'href'=>'',
                            'icon'=>'fa fa-user',
                            'target'=>'_self',
                            'child'=>array
                            (
                                [
                                    'title'=>'会员列表',
                                    'href'=>'/admin/user',
                                    'icon'=>'fa fa-user-o',
                                    'target'=>'_self',
                                ],
                            )
                        ],
                        [
                            'title'=>'系统设置',
                            'href'=>'',
                            'icon'=>'fa fa-gears',
                            'target'=>'_self',
                            'child'=>array
                            (
                                [
                                    'title'=>'站点信息',
                                    'href'=>'/admin/system',
                                    'icon'=>'fa fa-cog',
                                    'target'=>'_self',
                                ],
                                [
                                
                                    'title'=>'公司信息',
                                    'href'=>'/admin/company',
                                    'icon'=>'fa fa-copyright',
                                    'target'=>'_self',
                                ],
                                
                            )
                        ],
                        
                    )
                ]
            ),
        ];
       

        $json=json($menu);
        return $json;
    }

    public function page()
    {
        $model=Db::name('model')->where('status',1)->where('type',2)->field(['concat(ifnull(name,""),"内容") as title','concat("/admin/content/?id=",ifnull(id,"")) as href','concat("fa fa-file-text-o",ifnull("","")) as icon','concat("_self",ifnull("","")) as target'])->order('sort asc,id asc')->select();
        
        return $model;
    }

    public function images()
    {
        return View::fetch('images');
    }

    public function imageslist()
    {
        return View::fetch('imageslist');
    }
    
    public function directory_images()
    {
        return View::fetch('directory_images');
    }
    

    public function clear()
    {
        $count=Db::name('count')->delete(true);
        if($count){
            return json(['msg'=>'清除成功','status'=>'success']);
        }else{
            return json(['msg'=>'清除失败','status'=>'fail']);
        }
        
    }

    public function clearCache()
    {
        // 清除所有缓存
        Cache::clear();

        // 手动删除缓存目录中的文件，排除 session 文件夹
        $runtimePath = root_path() . 'runtime' . DIRECTORY_SEPARATOR;
        $this->deleteFiles($runtimePath, ['session']);

        // 返回成功消息
        return json(['code'=>'1','msg'=>'清理缓存成功']);
        
    }

    private function deleteFiles($path, $excludeDirs = [])
    {
        if (is_dir($path)) {
            $files = scandir($path);
            foreach ($files as $file) {
                if ($file != '.' && $file != '..') {
                    $fullPath = $path . DIRECTORY_SEPARATOR . $file;
                    if (is_dir($fullPath)) {
                        if (!in_array($file, $excludeDirs)) {
                            $this->deleteFiles($fullPath, $excludeDirs);
                            rmdir($fullPath);
                        }
                    } else {
                        unlink($fullPath);
                    }
                }
            }
        }
    }

    public function index()
    {
        return View::fetch();
    }

    // 获取报表数据
    public function getChartData()
    {
        // 获取最近30天的日期
        $dates = [];
        for ($i = 14; $i >= 0; $i--) {
            $dates[] = date('m-d', strtotime("-{$i} days"));
        }

        // 获取count表中的每日统计量
        $visitors = [];
        foreach ($dates as $date) {
            $startOfDay = date('Y') . '-' . $date . ' 00:00:00';
            $endOfDay = date('Y') . '-' . $date . ' 23:59:59';
            $count = Db::name('count')->whereBetweenTime('time', $startOfDay, $endOfDay)->count();
            $visitors[] = $count;
        }

        // 获取设备访问统计数据
        $deviceStats = Db::name('count')
            ->field('device_type, COUNT(*) as count')
            ->group('device_type')
            ->select()
            ->toArray();

        // 格式化设备访问统计数据
        $formattedDeviceStats = [];
        foreach ($deviceStats as $stat) {
            $formattedDeviceStats[] = [
                'value' => $stat['count'],
                'name' => $stat['device_type'] == '手机' ? '手机' : '电脑'
            ];
        }


        return json(['status' => 'success', 'data' => ['dates' => $dates, 'visitors' => $visitors,'deviceStats' => $formattedDeviceStats]]);
    }


    function get_count(Request $request)
    {
        $limit = $request->param('limit')?$request->param('limit'):5;
        $table = Db::name('count')->order('id desc')->paginate(['list_rows'=>$limit])->toArray();
        return json(['code'=>0, 'count'=>$table['total'], 'data'=>$table['data']]);
    }
    

    public function welcome()
    {

        $count = Db::name('count')->count();
        $count_day = Db::name('count')->whereBetweenTime('time', date('Y-m-d 00:00:00'), date('Y-m-d 23:59:59'))->count();

        // 获取表单数据
        $msg = Db::name('msg')->where('form_id', 1)->order('sign desc')->select()->toArray();

        // 按照 sign 分组
        $groupedMsg = [];
        foreach ($msg as $item) {
            $groupedMsg[$item['sign']][] = $item;
        }

        // 获取总记录数
        $msg = count($groupedMsg);

        $banner=Db::name('banner')->count();
        $link=Db::name('link')->count();
        $thinkphp=App::version();
        View::assign([
            'sys_info'=>$this->get_sys_info(),
            'msg'=>$msg,
            'banner'=>$banner,
            'link'=>$link,
            'count'=>$count,
            'count_day'=>$count_day,
            'thinkphp'=>$thinkphp,
        ]);
        return View::fetch();
    }

    public function user_password()
    {
        if($data=input('post.')){
            $admin=Db::name('admin')->where(['id'=>$data['id']])->find();
            if(md5($data['old_password'])!==$admin['password']){
                return json(['status'=>'fail','msg'=>"旧密码不正确！"]);
               
            }
            $password=Db::name('admin')->where(['id'=>$data['id']])->update(['password'=>md5($data['new_password'])]);
            if($password){
                session(null);
                return json(['status'=>'success','msg'=>"修改密码成功，请重新登录！"]);
            }else{
                return json(['status'=>'fail','msg'=>"修改密码错误！"]);
            }
        }
        return View::fetch();
    }
    
    public function user_setting()
    {
        if($data=input('post.')){
            $admin=Db::name('admin')->where(['id'=>$data['id']])->save($data);
            if($admin){
                return json(['status'=>'success','msg'=>'更新成功']);
            }else{
                return json(['status'=>'fail','msg'=>'更新失败']);
            }
        }
        $adname =session('adname');
        $setting=Db::name('admin')->where(['id'=>$adname['id']])->find();
        View::assign([
            'setting'=>$setting,
        ]);
        return View::fetch();
    }

    public function get_sys_info()
    {
        $sys_info['os']             = PHP_OS;
        $sys_info['zlib']           = function_exists('gzclose') ? 'YES' : '<font color="red">NO（请开启 php.ini 中的php-zlib扩展）</font>';//zlib
        $sys_info['safe_mode']      = (boolean) ini_get('safe_mode') ? 'YES' : 'NO';//safe_mode = Off       
        $sys_info['timezone']       = function_exists("date_default_timezone_get") ? date_default_timezone_get() : "no_timezone";
        $sys_info['curl']           = function_exists('curl_init') ? 'YES' : '<font color="red">NO（请开启 php.ini 中的php-curl扩展）</font>';  
        $web_server                 = $_SERVER['SERVER_SOFTWARE'];
        if (stristr($web_server, 'apache')) {
            $web_server = 'apache';
        } else if (stristr($web_server, 'nginx')) {
            $web_server = 'nginx';
        } else if (stristr($web_server, 'iis')) {
            $web_server = 'iis';
        }
        $sys_info['web_server']     = $web_server;
        $sys_info['phpv']           = phpversion();
        $sys_info['postsize']       = @ini_get('file_uploads') ? ini_get('post_max_size') :'未知';
        $sys_info['fileupload']     = @ini_get('file_uploads') ? ini_get('upload_max_filesize') :'未开启';
        $sys_info['max_ex_time']    = @ini_get("max_execution_time").'s'; //脚本最大执行时间
        $sys_info['set_time_limit'] = function_exists("set_time_limit") ? true : false;
        $sys_info['domain']         = $_SERVER['HTTP_HOST'];
       
        $sys_info['memory_limit']   = ini_get('memory_limit');
        $mysqlinfo = Db::query("SELECT VERSION() as version");
        $sys_info['mysql_version']  = $mysqlinfo[0]['version'];
        if(function_exists("gd_info")){
            $gd = gd_info();
            $sys_info['gdinfo']     = $gd['GD Version'];
        }else {
            $sys_info['gdinfo']     = "未知";
        }
        if (extension_loaded('zip')) {
            $sys_info['zip']     = "YES";
        } else {
            $sys_info['zip']     = '<font color="red">NO（请开启 php.ini 中的php-zip扩展）</font>';
        }

        return $sys_info;
    }

}
