<?php

/**
 * 获取文件扩展名并转为大写
 */
function get_file_ext($filepath) {
    return strtoupper(pathinfo($filepath, PATHINFO_EXTENSION));
}

/**
 * 格式化文件大小
 */
function get_file_size($filepath) {
    if (!file_exists('.' . $filepath)) return '未知';
    
    $size = filesize('.' . $filepath);
    $units = ['B', 'KB', 'MB', 'GB', 'TB'];
    $i = 0;
    while ($size >= 1024 && $i < count($units) - 1) {
        $size /= 1024;
        $i++;
    }
    return round($size, 2) . $units[$i];
}